#!/bin/sh
#
# Used with FVWM2 to generate a menu of last run items
#

export HTHEME=$HOME/.fvwm/cde
g_dir_data=$HTHEME/data
g_menu_fmt=$g_dir_data/last_run_x_fmt.txt
g_file_progs=$g_dir_data/last_run_x.txt

if [ "$USER" = "" ]; then
    export USER="`id -un`"
fi

if [ -d "$TMPDIR" ]; then
    g_tfile1=$TMPDIR/temp.menu.y.$USER
    g_tfile2=$TMPDIR/temp.menu.x.$USER
else
    g_tfile1=$g_dir_data/temp.menu.y.$USER
    g_tfile2=$g_dir_data/temp.menu.x.$USER
fi

if [ -f "$g_menu_fmt" ]; then
    sed 's/^/+ "/;s/$/"/' "$g_menu_fmt" > $g_tfile1
    sed 's/^/Exec /'      "$g_menu_fmt" > $g_tfile2
    paste $g_tfile1 $g_tfile2
    echo '+	""		Nop'
    echo '+ 	"Pin Menu" TearMenuOff'
    rm $g_tfile1 $g_tfile2 > /dev/null 2>&1
fi

################################################################################
# How to configure to allow saving of last run items
################################################################################

# 1. add the following somewhere in your .fvwm2rc
#
#     AddToMenu menu_dyn1 "Last Executed" title
#     + DynamicPopupAction Function make_dyn1
#     AddToFunc make_dyn1
#     + I DestroyMenu recreate menu_dyn1
#     + I AddToMenu menu_dyn1 "Last Executed" title
#     + I PipeRead PATH_TO/last_run.sh

# 2. add this entry somewhere in your menu structure
#
#   + "Last Run"   Popup menu_dyn1

# 3. all menu items you want to save in the "last Run"
#    menu, use xrun_prog.sh
#
#    Example -- my Libre Office Menu:
#
#         AddToMenu menu_loffice "Libre Office" Title
#         + "Spreadsheet"      Exec ~/.fvwm/cde/bin/xrun_prog.sh scalc
#         + "Word Processor"   Exec ~/.fvwm/cde/bin/xrun_prog.sh swriter
#         + "Presentation"     Exec ~/.fvwm/cde/bin/xrun_prog.sh simpress
#         + "Database"         Exec ~/.fvwm/cde/bin/xrun_prog.sh sbase
#         + "Math Editor"      Exec ~/.fvwm/cde/bin/xrun_prog.sh smath
#         + "Draw"             Exec ~/.fvwm/cde/bin/xrun_prog.sh sdraw
#         + "Open Office Main" Exec ~/.fvwm/cde/bin/xrun_prog.sh soffice
#         + "Printer Admin"    Exec ~/.fvwm/cde/bin/xrun_prog.sh spadmin
