#!/bin/sh
#
# xprop seems to have better information
# but now uses both
#

uarg="$1"
sleep_sec="1"

#------------------------------------------------------------------------------
# parse arguments
#------------------------------------------------------------------------------
rmode="info"
for uarg in "$@"
do
    case "$uarg" in
	"xkill")
	    rmode="xkill"
	    ;;
	"info")
	    rmode="info"
	    ;;
	*)
	    numb=`expr $sleep_sec + 1 - 1` > /dev/null 2>&1
	    if test "$?" -eq "0"
	    then
		if test "$uarg" -gt "0" -a "$uarg" -lt "301"
		then
		    sleep_sec="$uarg"
		else
		    sleep_sec="2"
		fi
	    fi
	    ;;
    esac
done

#------------------------------------------------------------------------------
# execute another utility
#------------------------------------------------------------------------------
case "$rmode" in
    "xkill")
	sleep $sleep_sec
	xkill
	exit 0
	;;
esac

##############################################################################
# what follows relates to xwindow
##############################################################################
if [ "$USER" = "" ]; then
    export USER="`id -un`"
fi

#------------------------------------------------------------------------------
# checks
#------------------------------------------------------------------------------
export HTHEME=$HOME/.fvwm/cde
g_dir_data=$HTHEME/data

type notify-send > /dev/null 2>&1
if [ "$?" = "0" ]; then
    g_notify="notify-send"
else
    g_notify="xmessage -timeout 3"
fi

type xless > /dev/null 2>&1
if [ "$?" -eq "0" ]; then
    g_pshow=xless
else
    type xmore > /dev/null 2>&1
    if [ "$?" -eq "0" ]; then
	g_pshow=xmore
    else
	type gvim > /dev/null 2>&1
	if [ "$?" -eq "0" ]; then
	    g_pshow=gvim -R "$g_tfile"
	else
	    $g_notify "$(basename $0) E01: cannot find a graphical display utility" &
	    exit 0
	fi
    fi
fi

type xwininfo > /dev/null 2>&1
if [ "$?" -ne "0" ]; then
    $g_notify "$(basename $0) E02: cannot find xwininfo" &
    exit 0
fi
type xprop > /dev/null 2>&1
if [ "$?" -ne "0" ]; then
    $g_notify "$(basename $0) E03: cannot find xprop" &
    exit 0
fi

if test -d /mnt/tmpfs
then
    g_tdir=/mnt/tmpfs
else
    g_tdir=$g_dir_data
fi

umask 077

g_tfile="$g_tdir/temp.$USER.$$.xwininfo"
touch "$g_tfile"
chmod 600 $g_tfile

#------------------------------------------------------------------------------
# checks
#------------------------------------------------------------------------------
cat << EOF >> "$g_tfile"
===============================================================================
| `date '+%Y/%m/%d  %H:%M:%S'` -- X window information from xwininfo and xprop
===============================================================================
| xwininfo
-------------------------------------------------------------------------------
`sleep $sleep_sec`
`xwininfo`
EOF

wid=`grep '^xwininfo: Window id: 0x' < "$g_tfile" | awk '{print $4}'`


cat << EOF >> "$g_tfile"
===============================================================================
| xprop : ID $wid
-------------------------------------------------------------------------------
`xprop -id "$wid"`
===============================================================================
*** END'
EOF

$g_pshow "$g_tfile"

rm -f "$g_tfile"

exit 0
